package com.codenameonefr.cn1filmsbox;


import com.codename1.io.Preferences;
import com.codename1.ui.Display;
import com.codename1.ui.Form;
import com.codename1.ui.plaf.UIManager;
import com.codename1.ui.util.Resources;
import java.io.IOException;
import java.util.Hashtable;

public class CN1FilmsBox {

    private Form current;
    public static Resources theme;
     
    private Accueil accueil;
    private FilmsPopulaires fPopup;
    private Parametres parametres;
    private static String langue=null;
    
    public void init(Object context) {
        try {
            theme = Resources.openLayered("/theme");
            UIManager.getInstance().setThemeProps(theme.getTheme(theme.getThemeResourceNames()[0]));
        } catch(IOException e){
            e.printStackTrace();
        }
        
        //--------Code de localication-------------------------------
        int choix_lang=Preferences.get("Lang_Pref",0);
        if(choix_lang==0){
            langue="fr";
        } else if(choix_lang==1){
            langue="en";
        }
        Hashtable loc=theme.getL10N("Traductions", langue);
        UIManager.getInstance().setBundle(loc);
        //--------Code de localication-------------------------------
    }
    
    public void start() { 
        if(current != null){
            current.show();
            return;
        }
        
        accueil=new Accueil(this);
        fPopup=new FilmsPopulaires(this);
        parametres=new Parametres(this);
        
        accueil.show();
    }

    public void stop() {
        current = Display.getInstance().getCurrent();
    }
    
    public void destroy() {
    }
    
    public static String getLangue()
    {
        return langue;
    }
    
    public void afficheAccueil(){
        accueil.show();
    }
    
    public void afficheFilmsPopulaires(){
        fPopup.show();
    }
    
    public void afficheParametres(){
        parametres.chargerParametres();
        parametres.show();
    }
}
