/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.codenameonefr.cn1filmsbox;

import com.codename1.components.InfiniteProgress;
import com.codename1.components.SpanLabel;
import com.codename1.io.NetworkManager;
import com.codename1.ui.Button;
import com.codename1.ui.Command;
import com.codename1.ui.Container;
import com.codename1.ui.Dialog;
import com.codename1.ui.Form;
import com.codename1.ui.Label;
import com.codename1.ui.Tabs;
import com.codename1.ui.TextField;
import com.codename1.ui.Toolbar;
import com.codename1.ui.events.ActionEvent;
import com.codename1.ui.events.ActionListener;
import com.codename1.ui.layouts.BorderLayout;
import com.codename1.ui.layouts.BoxLayout;

/**
 *
 * @author Doderic
 */
public class FilmsPopulaires extends Form implements ActionListener {
    
    private static CN1FilmsBox main;
    private TextField zoneRecherche;
    private Button boutonRecherche;
    private Command retour;
    private Tabs tabs;
    private Container filmsPopuActuContainer;
    private Container filmsPopuAnContainer;
    
    public FilmsPopulaires(CN1FilmsBox main) {
        this.main=main;
        BorderLayout mainLayout=new BorderLayout();
        setLayout(mainLayout);
        
        /*Ces 2 mthodes crent un Container et y ajoutent du contenu.
        Les containers de ces mthodes seront ajouts aux onglets qui seront crs plus bas*/
        ongletFilmsPopulairesActu();
        ongletFilmsPopulairesAnnee();
        
        //Cration d'un page  onglet et ajout des 2 containers crs prcdemmment  l'intrieur des onglets
        tabs=new Tabs();
        tabs.setSwipeActivated(false);
        tabs.addTab("Actuellement", filmsPopuActuContainer);
        tabs.addTab("De l'anne XXXX", filmsPopuAnContainer);
        
        /*Cration d'un contenu qui sera ajout au toolbar qui sera cr plus bas.
        Ce contenu est compos d'un container, d'une zone de texte et d'un bouton*/
        Container toolbarC=new Container(new BorderLayout());
        zoneRecherche=new TextField();
        zoneRecherche.setHint("Anne de recherche");
        boutonRecherche=new Button(CN1FilmsBox.theme.getImage("rech.png"));
        toolbarC.addComponent(BorderLayout.CENTER,zoneRecherche);
        toolbarC.addComponent(BorderLayout.EAST,boutonRecherche);
        
        //Cration de la commande Retour qui servira  retourner  l'interface d'accueil
        retour=new Command("Retour");
        setBackCommand(retour);
        
        /* Cration d'un Toolbar  placer sur la barre de titre.
        Ce toolbar contiendra un Container qui aura une zone de texte et un bouton.
        Ajout de la commande Retour au toolbar qui se chargera de l'ajouter  un menu hamburger*/
        Toolbar toolbar=new Toolbar();
        setToolBar(toolbar);
        toolbar.setTitleComponent(toolbarC);
        toolbar.addCommandToSideMenu(retour);
        
        addComponent(BorderLayout.CENTER,tabs);

        boutonRecherche.addActionListener(this);
        addCommandListener(this);
    }
    
    private void ongletFilmsPopulairesActu()
    {
        //Cration d'un container suivie de l'activation du dfilement vertical. 
        filmsPopuActuContainer=new Container(new BoxLayout(BoxLayout.Y_AXIS));
        filmsPopuActuContainer.setScrollableY(true);
        
        //Cration et affichage d'un message pour indiquer  l'utilisateut l'action  excuter
        SpanLabel info=new SpanLabel("Tirez et relchez cette surface pour charger la liste des films populaires du moment");
        info.getStyle().setAlignment(Label.CENTER);
        filmsPopuActuContainer.addComponent(info);
        
        /* Si l'utilisateur tire et relche la surface du Container alors la mthode 
        chargerFilmsPopulairesActu() sera appele */
        filmsPopuActuContainer.addPullToRefresh(new Runnable() {

            public void run() {
                chargerFilmsPopulairesActu();
            }
        });
    }
    
    private void ongletFilmsPopulairesAnnee()
    {
        //Cration d'un container suivie de l'activation du dfilement vertical. 
        filmsPopuAnContainer=new Container(new BoxLayout(BoxLayout.Y_AXIS));
        filmsPopuAnContainer.setScrollableY(true);
    }
    
    private void chargerFilmsPopulairesActu(){
        //S'il y a un composant danns le container du premier onglet alors les supprimer tous
        if(filmsPopuActuContainer.getComponentCount()>0){
            filmsPopuActuContainer.removeAll();
        }
        //Cration de la requte HTTP  travers la classe RequeteReseau qui hrite de ConnectionRequest
        RequeteReseau requete=new RequeteReseau(filmsPopuActuContainer,"https://api.themoviedb.org/3/movie/popular");
        NetworkManager.getInstance().addToQueue(requete);   
        
        InfiniteProgress progress=new InfiniteProgress();
        Dialog d=progress.showInifiniteBlocking();
        requete.setDisposeOnCompletion(d);
    }
    
    private void chargerFilmsPopulairesAnnee(){
        //Affichage du deuxime onglet
        tabs.setSelectedIndex(1);
        
        String anneeRecherche=zoneRecherche.getText().trim();
        if(anneeRecherche.length()==0 || anneeRecherche.length()!=4){
            Dialog.show("", "Entrez une anne valide", "Ok", null);
            return;
        }
        //S'il y a un composant danns le container du premier onglet alors les supprimer tous
        if(filmsPopuAnContainer.getComponentCount()>0){
            filmsPopuAnContainer.removeAll();
        }
        
        /*Cration de la requte HTTP  travers la classe RequeteReseau qui hrite de ConnectionRequest.
        Ajout de l'URL et de 3 paramtres et valeurs  la requte sous forme d'arguments*/
        RequeteReseau requete=new RequeteReseau(filmsPopuAnContainer,"https://api.themoviedb.org/3/discover/movie");
        requete.addArgument("primary_release_year", anneeRecherche);
        requete.addArgument("sort_by", "vote_average.desc");
        requete.addArgument("language", "fr");
        NetworkManager.getInstance().addToQueue(requete);

        InfiniteProgress progress=new InfiniteProgress();
        Dialog d=progress.showInifiniteBlocking();
        requete.setDisposeOnCompletion(d);
    }
    
    /*Cette mthode prend en paramtre les donnes retournes par la requte HTTP,
    cr une nouvelle fentre et affiche ces donnes sur l'interface avec des Label.*/    
    public static void afficheDetailsFilm(String titreFilm, String dateSortieFilm, String noteFilm, String nbreVote)
    {
        Form filmDetails=new Form(titreFilm);
        filmDetails.setLayout(new BoxLayout(BoxLayout.Y_AXIS));

        SpanLabel titre=new SpanLabel("Titre: "+titreFilm); 
        Label date=new Label("Date de sortie: "+dateSortieFilm); 
        Label note=new Label("Note moyenne: "+noteFilm); 
        Label vote=new Label("Nombre de votes: "+nbreVote); 

        Command ret=new Command("Retour");
        filmDetails.setBackCommand(ret);

        filmDetails.addComponent(titre);
        filmDetails.addComponent(date);
        filmDetails.addComponent(note);
        filmDetails.addComponent(vote);

        filmDetails.addCommand(ret);
        filmDetails.addCommandListener(new ActionListener() {

            public void actionPerformed(ActionEvent evt) {
                main.afficheFilmsPopulaires();
            }
        });

        filmDetails.show();
    }

    public void actionPerformed(ActionEvent evt) {
        Command cmd=evt.getCommand();
        Object obj=evt.getSource();
        
        if(obj==boutonRecherche){
            /* Si le bouton de recherche est appuy, appeler la mthode chargerFilmsPopulairesAnnee()
             pour lancer la cration de la requteet la rcupration des rsultats */
            chargerFilmsPopulairesAnnee();
        }
        //Si la commande retour est appuye, retourner  l'interface principal
        if(cmd==retour){
            main.afficheAccueil();
        }
    }
    
}
