package com.mycompany.myapp;


import com.codename1.ui.Button;
import com.codename1.ui.Display;
import com.codename1.ui.Form;
import com.codename1.ui.Label;
import com.codename1.ui.animations.CommonTransitions;
import com.codename1.ui.animations.FlipTransition;
import com.codename1.ui.events.ActionEvent;
import com.codename1.ui.events.ActionListener;
import com.codename1.ui.layouts.BoxLayout;
import com.codename1.ui.plaf.UIManager;
import com.codename1.ui.util.Resources;
import java.io.IOException;

public class Transitions {

    private Form current;

    public void init(Object context) {
        try {
            Resources theme = Resources.openLayered("/theme");
            UIManager.getInstance().setThemeProps(theme.getTheme(theme.getThemeResourceNames()[0]));
        } catch(IOException e){
            e.printStackTrace();
        }

    }
    
    public void start() {
        if(current != null){
            current.show();
            return;
        }
        
        final Form f = new Form("Page 1");
f.setLayout(new BoxLayout(BoxLayout.Y_AXIS));
Button b=new Button("Aller  la seconde page");
f.addComponent(b);

f.setTransitionOutAnimator(CommonTransitions.createSlide(
CommonTransitions.SLIDE_VERTICAL, true, 1000));

final Form f2 = new Form("Page 2");
f2.setLayout(new BoxLayout(BoxLayout.Y_AXIS));
Button b2=new Button("Aller  la troisime page");
f2.addComponent(b2);

f2.setTransitionOutAnimator(CommonTransitions.createFade(1000));

final Form f3 = new Form("Page 3");
f3.setLayout(new BoxLayout(BoxLayout.Y_AXIS));
Button b3=new Button("Aller  la quatrime page");
f3.addComponent(b3);

f3.setTransitionOutAnimator(CommonTransitions.createCover(
CommonTransitions.SLIDE_HORIZONTAL, false, 1000));

final Form f4 = new Form("Page 4");
f4.setLayout(new BoxLayout(BoxLayout.Y_AXIS));
Button b4=new Button("Retourner  la premire page");
f4.addComponent(b4);

f4.setTransitionOutAnimator(new FlipTransition());

b.addActionListener(new ActionListener() {
public void actionPerformed(ActionEvent evt) {
f2.show();
}
});

b2.addActionListener(new ActionListener() {
public void actionPerformed(ActionEvent evt) {
f3.show();
}
});

b3.addActionListener(new ActionListener() {
public void actionPerformed(ActionEvent evt) {
f4.show();
}
});

b4.addActionListener(new ActionListener() {
public void actionPerformed(ActionEvent evt) {
f.show();
}
});


f.show();
    }

    public void stop() {
        current = Display.getInstance().getCurrent();
    }
    
    public void destroy() {
    }

}
