package com.mycompany.myapp;


import com.codename1.components.InfiniteProgress;
import com.codename1.io.ConnectionRequest;
import com.codename1.io.JSONParser;
import com.codename1.io.NetworkManager;
import com.codename1.ui.Button;
import com.codename1.ui.Command;
import com.codename1.ui.Component;
import com.codename1.ui.Container;
import com.codename1.ui.Dialog;
import com.codename1.ui.Display;
import com.codename1.ui.Form;
import com.codename1.ui.TextField;
import com.codename1.ui.events.ActionEvent;
import com.codename1.ui.events.ActionListener;
import com.codename1.ui.layouts.BorderLayout;
import com.codename1.ui.layouts.BoxLayout;
import com.codename1.ui.layouts.FlowLayout;
import com.codename1.ui.plaf.UIManager;
import com.codename1.ui.util.Resources;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Hashtable;
import java.util.Map;

public class CN1BDDDistante implements ActionListener {

    private Form current;
    private Command quitter;
    private TextField login;
    private TextField password;
    private Button inscription;

    public void init(Object context) {
        try {
            Resources theme = Resources.openLayered("/theme");
            UIManager.getInstance().setThemeProps(theme.getTheme(theme.getThemeResourceNames()[0]));
        } catch(IOException e){
            e.printStackTrace();
        }
    }
    
    public void start() {
        if(current != null){
            current.show();
            return;
        }
        Form f = new Form("Base de donne distante");
        BorderLayout mainLayout=new BorderLayout();
        mainLayout.setCenterBehavior(BorderLayout.CENTER_BEHAVIOR_CENTER_ABSOLUTE);
        f.setLayout(mainLayout);
        
        Container mainContainer=new Container(new BoxLayout(BoxLayout.Y_AXIS));
        
        login=new TextField();
        login.setHint("Entrez votre identifiant");
        
        password=new TextField();
        password.setHint("Entre votre mot de passe");
        password.setConstraint(TextField.PASSWORD);
        
        inscription=new Button("Je m'inscris");
        inscription.setw
        
        mainContainer.addComponent(login);
        mainContainer.addComponent(password);
        mainContainer.addComponent(inscription);
        
        quitter=new Command("Quitter");
        
        f.addComponent(BorderLayout.CENTER, mainContainer);
        f.addCommand(quitter);
        
        inscription.addActionListener(this);
        f.addCommandListener(this);
        f.show();
    }

    public void stop() {
        current = Display.getInstance().getCurrent();
    }
    
    public void destroy() {
    }

    public void actionPerformed(ActionEvent evt) {
        
        if(evt.getSource()==inscription){
            
            ConnectionRequest requete=new ConnectionRequest(){
                
                Map data;
    
                @Override
                protected void postResponse() {
                   Dialog.show("",(String)data.get("reponse"), "Ok", null);
                    
                }

                @Override
                protected void readResponse(InputStream input) throws IOException {
                    JSONParser parser=new JSONParser();
                    data=parser.parseJSON(new InputStreamReader(input));
                    //System.out.println(data);
                }
                
            };
            
            requete.setUrl("http://localhost/RESTCN1/inscription.php");
            requete.setPost(true);
            requete.addArgument("identifiant", login.getText());
            requete.addArgument("motdepasse", password.getText());
            NetworkManager.getInstance().addToQueue(requete);
            
            InfiniteProgress progress=new InfiniteProgress();
            Dialog d=progress.showInifiniteBlocking();
            requete.setDisposeOnCompletion(d);

            
        }
        
        if(evt.getCommand()==quitter){
            Display.getInstance().exitApplication();
        }
        
    }

}
