package com.mycompany.myapp;


import com.codename1.components.FileTree;
import com.codename1.components.FileTreeModel;
import com.codename1.components.InfiniteProgress;
import com.codename1.io.FileSystemStorage;
import com.codename1.io.MultipartRequest;
import com.codename1.io.NetworkManager;
import com.codename1.ui.Dialog;
import com.codename1.ui.Display;
import com.codename1.ui.Form;
import com.codename1.ui.Image;
import com.codename1.ui.Label;
import com.codename1.ui.events.ActionEvent;
import com.codename1.ui.events.ActionListener;
import com.codename1.ui.layouts.BorderLayout;
import com.codename1.ui.layouts.BoxLayout;
import com.codename1.ui.plaf.UIManager;
import com.codename1.ui.util.Resources;
import java.io.IOException;
import java.io.InputStream;

public class CN1UploadTest {

    private Form current;

    public void init(Object context) {
        try {
            Resources theme = Resources.openLayered("/theme");
            UIManager.getInstance().setThemeProps(theme.getTheme(theme.getThemeResourceNames()[0]));
        } catch(IOException e){
            e.printStackTrace();
        }
        // Pro users - uncomment this code to get crash reports sent to you automatically
        /*Display.getInstance().addEdtErrorHandler(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                evt.consume();
                Log.p("Exception in AppName version " + Display.getInstance().getProperty("AppVersion", "Unknown"));
                Log.p("OS " + Display.getInstance().getPlatformName());
                Log.p("Error " + evt.getSource());
                Log.p("Current Form " + Display.getInstance().getCurrent().getName());
                Log.e((Throwable)evt.getSource());
                Log.sendLog();
            }
        });*/
    }
    
    public void start() {
        if(current != null){
            current.show();
            return;
        }
        
        final String URL_DESTINATION = "http://localhost/upload.php";
        //final String URL_DESTINATION = "http://codenameonefr.olympe.in/upload.php";
        Form f=new Form("Choisissez un fichier");
        f.setLayout(new BorderLayout());
        
        Image dossier_ouvert=null;
        Image dossier_ferme=null;
        try{
            dossier_ouvert=Image.createImage("/dossier_ouvert.png");
            dossier_ferme=Image.createImage("/dossier_ferme.png");
            
        } catch(IOException ex){
            Dialog.show("Erreur de chargement", ex.getMessage(), "Ok", null);
        }
        
        FileTree.setFolderIcon(dossier_ferme);
        FileTree.setFolderOpenIcon(dossier_ouvert);
//        FileTree.setNodeIcon(theme.getImage("Add_Zone.png"));
        FileTree ft=new FileTree();
        
        ft.addLeafListener(new ActionListener() {
            
            public void actionPerformed(ActionEvent evt) {
                String fichierChoisi=(String)evt.getSource();
                
                if(!fichierChoisi.toLowerCase().endsWith(".mp3")){
                    Dialog.show("Fichier invalide", "Le fichier choisi n'est pas un fichier MP3", "Ok", null);
                    return;
                }
                
                if(Dialog.show("Voulez-vous envoyer ce fichier?", fichierChoisi, "Oui", "Non")){
                    
                    InfiniteProgress iprogress=new InfiniteProgress();            
                    Dialog progress=iprogress.showInifiniteBlocking(); 

                    MultipartRequest requete=new MultipartRequest();
                    requete.setUrl(URL_DESTINATION);
                    requete.setPost(true);
                    //InputStream is = null;
                    try {
                        //is = FileSystemStorage.getInstance().openInputStream(filename);
                        //req.addData("content", is, MimeTypes.getInstance().getMimeType(filename));
                        requete.addData("contenu", fichierChoisi, "audio/mp3");
                        //requete.setFilename("contenu", fichierChoisi);
                        requete.setDisposeOnCompletion(progress);
                        NetworkManager.getInstance().addToQueue(requete);
                        
                    } catch (IOException ex) {
                       Dialog.show("Erreur", ex.getMessage(), "Ok", null);
                    }
                    
                }
            }
        });
        f.addComponent(BorderLayout.CENTER,ft);
        f.show();
    }

    public void stop() {
        current = Display.getInstance().getCurrent();
    }
    
    public void destroy() {
    }

}
