package com.mycompany.myapp;


import com.codename1.components.ImageViewer;
import com.codename1.components.InfiniteProgress;
import com.codename1.io.ConnectionRequest;
import com.codename1.io.FileSystemStorage;
import com.codename1.io.JSONParser;
import com.codename1.io.NetworkManager;
import com.codename1.io.Util;
import com.codename1.ui.Button;
import com.codename1.ui.Command;
import com.codename1.ui.Dialog;
import com.codename1.ui.Display;
import com.codename1.ui.Form;
import com.codename1.ui.Image;
import com.codename1.ui.TextField;
import com.codename1.ui.URLImage;
import com.codename1.ui.events.ActionEvent;
import com.codename1.ui.events.ActionListener;
import com.codename1.ui.layouts.BorderLayout;
import com.codename1.ui.layouts.BoxLayout;
import com.codename1.ui.list.DefaultListModel;
import com.codename1.ui.plaf.UIManager;
import com.codename1.ui.util.Resources;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.List;
import java.util.Map;
import java.util.Vector;

public class FlickrSlider implements ActionListener {

    private Form current;
    private Button telechargerImages;
    private Button afficherImages;
    private TextField motcle;
    private Vector imgs;
    private String racine;
    private Command retour;
    private Command quitter;
    private Form f;

    public void init(Object context) {
        try {
            Resources theme = Resources.openLayered("/theme");
            UIManager.getInstance().setThemeProps(theme.getTheme(theme.getThemeResourceNames()[0]));
        } catch(IOException e){
            e.printStackTrace();
        }

    }
    
    public void start() {
        if(current != null){
            current.show();
            return;
        }
        
        f=new Form("Flickr Slider");
        f.setLayout(new BoxLayout(BoxLayout.Y_AXIS));
        
        motcle=new TextField();
        motcle.setHint("Entrez un mot cl pour la recherche");
        telechargerImages=new Button("Tlcharger et afficher");
        afficherImages=new Button("Afficher les images");
        
        telechargerImages.addActionListener(this);
        afficherImages.addActionListener(this);
        
        quitter=new Command("Quitter");
        
        f.addCommand(quitter);
        f.addComponent(motcle);
        f.addComponent(telechargerImages);
        f.addComponent(afficherImages);
        f.addCommandListener(this);
        
        f.show();
    }

    public void stop() {
        current=Display.getInstance().getCurrent();
    }
    
    public void destroy() {
    }
    
    void creerAfficherSlide()
    {
        Form fSlide=new Form("Flickr Slider");
        fSlide.setLayout(new BorderLayout());
        
        ImageViewer viewer=new ImageViewer();
        DefaultListModel<Image> listeImage=new DefaultListModel<Image>();
        
        try {
            listeImage.addItem(Image.createImage(racine+"photo0.jpg"));
            listeImage.addItem(Image.createImage(racine+"photo1.jpg"));
            listeImage.addItem(Image.createImage(racine+"photo2.jpg"));
            listeImage.addItem(Image.createImage(racine+"photo3.jpg"));
            
        } catch(IOException ex){
            Dialog.show("Erreur", "Images non trouves", "Ok", null);
            return;
        }
        viewer.setImage(listeImage.getItemAt(0));
        viewer.setImageList(listeImage);
        
        retour=new Command("Accueil");
        fSlide.addCommand(retour);
        fSlide.setBackCommand(retour);
        
        fSlide.addComponent(BorderLayout.CENTER, viewer);
        fSlide.addCommandListener(this);
        fSlide.show();
    }

    public void actionPerformed(ActionEvent evt) {
        Object obj=evt.getSource();
        Command cmd=evt.getCommand();
        
        racine=FileSystemStorage.getInstance().getAppHomePath();
        if(!racine.endsWith("/")){
            racine+="/";
        }
        
        if(obj==telechargerImages){
            
            imgs=new Vector();
            
            ConnectionRequest requete=new ConnectionRequest(){

                @Override
                protected void postResponse() {
                    if(Dialog.show("", "Connexion tablie. Validez pour tlcharger les images", "OK", null)){
                        int nbreUrlImages=imgs.size();
                        for(int i=0;i<nbreUrlImages;i++){
                            Util.downloadUrlToFile((String)imgs.elementAt(i), racine+"photo"+i+".jpg", true);
                            
                            
                        }
                        imgs=null;
                        creerAfficherSlide();
                    }
                }

                @Override
                protected void readResponse(InputStream input) throws IOException {
                    JSONParser parser=new JSONParser();
                    Map m=parser.parseJSON(new InputStreamReader(input));
                    List items=(List)m.get("items");
                    
                    for(int i=0;i<4;i++){
                      Map item=(Map)items.get(i);
                      String urlImage=(String)((Map)item.get("media")).get("m");
                      imgs.addElement(urlImage);
                    }
                }
                                   
            };
            
            //requete.setUrl("http://localhost/flickr2.json");
            requete.setUrl("http://api.flickr.com/services/feeds/photos_public.gne");
            requete.setPost(false);
            
            String mCle=motcle.getText();
            if(mCle.length()==0){
                Dialog.show("", "Entrez un mot cl", "Ok", null);
                return;
            }
            requete.addArgument("tags", motcle.getText().trim());
            requete.addArgument("format", "json");
            NetworkManager.getInstance().addToQueue(requete);
            
            InfiniteProgress progress=new InfiniteProgress();
            Dialog d=progress.showInifiniteBlocking();
            requete.setDisposeOnCompletion(d); 
            
        } else if(obj==afficherImages){
            creerAfficherSlide();
        }
        
        if(cmd==retour){
            f.showBack();
            
        } else if(cmd==quitter){
            Display.getInstance().exitApplication();
        }
    }

}
