package com.mycompany.myapp;


import com.codename1.l10n.L10NManager;
import com.codename1.ui.Button;
import com.codename1.ui.Display;
import com.codename1.ui.Form;
import com.codename1.ui.Label;
import com.codename1.ui.TextField;
import com.codename1.ui.layouts.BoxLayout;
import com.codename1.ui.plaf.UIManager;
import com.codename1.ui.util.Resources;
import java.io.IOException;
import java.util.Hashtable;

public class Traductiontest {

    private Form current;
    private String langue;
    private Resources theme;

    public void init(Object context) {
        try {
            theme=Resources.openLayered("/theme");
            UIManager.getInstance().setThemeProps(theme.getTheme(theme.getThemeResourceNames()[0]));
        } catch(IOException e){
            e.printStackTrace();
        }
        
        L10NManager lm=Display.getInstance().getLocalizationManager();
        langue=lm.getLanguage();
        
        if(!langue.equals("fr")) {
            Hashtable loc=theme.getL10N("MesTraductions", "en");
            UIManager.getInstance().setBundle(loc);
        } 

    }
    
    public void start() {
        if(current != null){
            current.show();
            return;
        }
        final Form f=new Form("Traduction");
        f.setLayout(new BoxLayout(BoxLayout.Y_AXIS));
        
        Label nom=new Label("Nom");
        TextField nomF=new TextField();
        
        Label adresse=new Label("Adresse");
        TextField adresseF=new TextField();
        
        Label numero=new Label("Numro de tlphone");
        TextField numeroF=new TextField();
        numeroF.setConstraint(TextField.NUMERIC);
        
        Button envoyer=new Button("Envoyer");
        
        f.addComponent(nom);
        f.addComponent(nomF);
        f.addComponent(adresse);
        f.addComponent(adresseF);
        f.addComponent(numero);
        f.addComponent(numeroF);
        f.addComponent(envoyer);
        
        f.show();
    }

    public void stop() {
        current = Display.getInstance().getCurrent();
    }
    
    public void destroy() {
    }

}
