package com.codenameonefr.testplugin;


import com.codename1.ui.Button;
import com.codename1.ui.Dialog;
import com.codename1.ui.Display;
import com.codename1.ui.Form;
import com.codename1.ui.Label;
import com.codename1.ui.events.ActionEvent;
import com.codename1.ui.events.ActionListener;
import com.codename1.ui.layouts.BoxLayout;
import com.codename1.ui.plaf.UIManager;
import com.codename1.ui.util.Resources;
import com.pmovil.toast.Toast;
import java.io.IOException;

public class TestPlugin {

    private Form current;
    private Object mContext;

    public void init(Object context) {
        mContext=context;
        try {
            Resources theme = Resources.openLayered("/theme");
            UIManager.getInstance().setThemeProps(theme.getTheme(theme.getThemeResourceNames()[0]));
        } catch(IOException e){
            e.printStackTrace();
        }
        // Pro users - uncomment this code to get crash reports sent to you automatically
        /*Display.getInstance().addEdtErrorHandler(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                evt.consume();
                Log.p("Exception in AppName version " + Display.getInstance().getProperty("AppVersion", "Unknown"));
                Log.p("OS " + Display.getInstance().getPlatformName());
                Log.p("Error " + evt.getSource());
                Log.p("Current Form " + Display.getInstance().getCurrent().getName());
                Log.e((Throwable)evt.getSource());
                Log.sendLog();
            }
        });*/
    }
    
    public void start() {
        if(current != null){
            current.show();
            return;
        }
        
        Form f=new Form("Test Plugin");
        f.setLayout(new BoxLayout(BoxLayout.Y_AXIS));
        
        Button b=new Button("Affiche un Toast");
        b.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent evt) {
                if(Display.getInstance().getPlatformName().equals("and")){
                    Toast.makeText(mContext, "Coucou, je suis l ;-)", Toast.LENGTH_LONG).show();
                } else {
                    Dialog.show("Hi", "Coucou, je suis l ;-)", "Ok", null);
                }
                
            }
        });
        
        f.addComponent(b);
        
        f.show();
    }

    public void stop() {
        current = Display.getInstance().getCurrent();
    }
    
    public void destroy() {
    }

}
